/*
 * xrick/src/data.c
 *
 * Copyright (C) 1998-2002 BigOrno (bigorno@bigorno.net). All rights reserved.
 *
 * The use and distribution terms for this software are contained in the file
 * named README, which can be found in the root of this distribution. By
 * using this software in any fashion, you are agreeing to be bound by the
 * terms of this license.
 *
 * You must not remove this notice, or any other, from this software.
 *
 * 32X changes by Chilly Willy
 */

#include <stdlib.h>
#include <string.h>

#include "system.h"
#include "data.h"
#include "files.h"

static int foffs[NUM_FILES];

/*
 *
 */
void
data_setpath(char *name)
{
}

/*
 *
 */
void
data_closepath()
{
}

/*
 * Open.
 */
data_file_t *
data_file_open(char *name)
{
    int ix;

    for (ix=0; ix<NUM_FILES; ix++)
        if (!strcasecmp(name, fileName[ix]))
        {
            foffs[ix] = 0;
            return (data_file_t *)(ix + 1);
        }

    return (data_file_t *)0;
}

/*
 * Size.
 */
int
data_file_size(data_file_t *file)
{
	return fileSize[(int)file - 1];
}

/*
 * Seek.
 */
int
data_file_seek(data_file_t *file, long offset, int origin)
{
    switch (origin)
    {
        case SEEK_SET:
            foffs[(int)file - 1] = offset;
            break;
        case SEEK_CUR:
            foffs[(int)file - 1] += offset;
            break;
        case SEEK_END:
            foffs[(int)file - 1] = fileSize[(int)file - 1] + offset;
            break;
    }

    return foffs[(int)file - 1];
}

/*
 * Tell.
 */
int
data_file_tell(data_file_t *file)
{
    return foffs[(int)file - 1];
}

/*
 * Read.
 */
int
data_file_read(data_file_t *file, void *buf, size_t size, size_t count)
{
    memcpy(buf, (char *)(filePtr[(int)file - 1] + foffs[(int)file - 1]), size * count);
    return size * count;
}

/*
 * Memory Map.
 */
void *
data_file_mmap(data_file_t *file, long offset)
{
    return (void *)(filePtr[(int)file - 1] + offset);
}

/*
 * Close.
 */
void
data_file_close(data_file_t *file)
{
}
