/*
 * xrick/src/sysarg.c
 *
 * Copyright (C) 1998-2002 BigOrno (bigorno@bigorno.net). All rights reserved.
 *
 * The use and distribution terms for this software are contained in the file
 * named README, which can be found in the root of this distribution. By
 * using this software in any fashion, you are agreeing to be bound by the
 * terms of this license.
 *
 * You must not remove this notice, or any other, from this software.
 *
 * 32X changes by Chilly Willy
 */

/*
 * 20021010 added test to prevent buffer overrun in -keys parsing.
 */

#include <stdlib.h>  /* atoi */
#include <string.h>  /* strcasecmp */

#include "32x.h"
#include "hw_32x.h"

#include "system.h"
#include "config.h"
#include "game.h"

#include "maps.h"
#include "syssnd.h"

int sysarg_args_period = 0;
int sysarg_args_map = 0;
int sysarg_args_submap = 0;
int sysarg_args_fullscreen = 0;
int sysarg_args_nosound = 0;
int sysarg_args_vol = 0;
char *sysarg_args_data = NULL;

/*
 * Read and process arguments
 */
void
sysarg_init(int argc, char **argv)
{
  sysarg_args_fullscreen = 1;
  sysarg_args_period = 0;
  sysarg_args_map = 0;
  sysarg_args_submap = 0;
  sysarg_args_vol = SYSSND_MAXVOL;
  sysarg_args_nosound = 0;
  sysarg_args_data = NULL;

  syskbd_left = SEGA_CTRL_LEFT;
  syskbd_right = SEGA_CTRL_RIGHT;
  syskbd_up = SEGA_CTRL_UP;
  syskbd_down = SEGA_CTRL_DOWN;
  syskbd_fire = SEGA_CTRL_A;
  syskbd_pause = SEGA_CTRL_START;
  syskbd_end = SEGA_CTRL_C;

  /* this is dirty (sort of) */
  if (sysarg_args_submap > 0 && sysarg_args_submap < 9)
    sysarg_args_map = 0;
  if (sysarg_args_submap >= 9 && sysarg_args_submap < 20)
    sysarg_args_map = 1;
  if (sysarg_args_submap >= 20 && sysarg_args_submap < 38)
    sysarg_args_map = 2;
  if (sysarg_args_submap >= 38)
    sysarg_args_map = 3;
  if (sysarg_args_submap == 9 ||
      sysarg_args_submap == 20 ||
      sysarg_args_submap == 38)
    sysarg_args_submap = 0;
}

/* eof */
